#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "DBDTunableRowHandle.h"
#include "K28KillerLockerState.h"
#include "Templates/SubclassOf.h"
#include "K28KillerLockerComponent.generated.h"

class UCurveFloat;
class AAnimationFollowerActor;
class ADBDPlayer;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class THEK28_API UK28KillerLockerComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _targetLockerFOV;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	UCurveFloat* _fovChangeTeleportationCurve;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _fovChangeTime;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, ReplicatedUsing=OnRep_LockerState_Replicated, Transient, meta=(AllowPrivateAccess=true))
	FK28KillerLockerState _lockerState_replicated;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	FK28KillerLockerState _lockerState;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<AAnimationFollowerActor> _extraArmsAnimationFollowerActorClass;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	AAnimationFollowerActor* _extraArmsAnimationFollowerActor;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _timeBetweenAttemptTrigger;

private:
	UFUNCTION(BlueprintCallable)
	void OnRep_LockerState_Replicated();

	UFUNCTION(BlueprintCallable)
	void OnPlayerInLockerChanged(ADBDPlayer* previousPlayerInLocker, ADBDPlayer* newPlayerInLocker);

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK28KillerLockerComponent();
};

FORCEINLINE uint32 GetTypeHash(const UK28KillerLockerComponent) { return 0; }
